#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>
#include <arpa/inet.h>
#include <sys/socket.h>
#include <fcntl.h>

void error_handling(char *message);

int main(int argc, char* argv[])
{
	int sock;
	int fd;
	int cnt;
	struct sockaddr_in serv_addr;
	char message[100];
	int str_len;
	
	if(argc!=4){
		printf("Usage : %s <IP> <port> <file>\n", argv[0]);
		exit(1);
	}
	fd = open(argv[3],O_RDONLY);
	if(fd < 0)
	{
		printf("%s open error\n",argv[3]);
		perror("open ");
		exit(1);
	}
	
	sock=socket(PF_INET, SOCK_STREAM, 0);
	if(sock < 0)
		error_handling("socket() error");
	
	memset(&serv_addr, 0, sizeof(serv_addr));
	serv_addr.sin_family=AF_INET;
	serv_addr.sin_addr.s_addr=inet_addr(argv[1]);
	serv_addr.sin_port=htons(atoi(argv[2]));
		
	if(connect(sock, (struct sockaddr*)&serv_addr, sizeof(serv_addr))<0) 
		error_handling("connect() error!");
	
	while(1)
	{
		cnt = read(fd,message,sizeof(message));
		if(cnt > 0)
		{
			write(sock, message, cnt);
		}
		else if(cnt == 0)
		{
        	puts("done..\n");
			break;
		}
		else
			error_handling("read() Error");

	}
	close(sock);
	close(fd);
	return 0;
}

void error_handling(char *message)
{
	fputs(message, stderr);
	fputc('\n', stderr);
	exit(1);
}
